/*
 *
 * URL:       $URL$
 * Revision:  $Revision: #1 $
 * Date:      $Date: 2017/11/02 $
 * Author:    $Author: build $
 *
 * (C) Copyright 2002-2012 Riverbed Technology, Inc.
 * All rights reserved.
 *
 */

static const char rcsid[] = "$Id: //depot/prod/cag/R4.4.1x/net-snmp/net-snmp-5.7.1/agent/sn_scalars.c#1 $";

#include "common.h"
#include "sn_main.h"
#include "sn_registration.h"
#include "sn_scalars.h"
#include "sn_utils.h"


/* ------------------------------------------------------------------------- */
/*
 * This is pretty simple.  The only thing we can return is our
 * registered OID with a "0" added to it.  So construct this OID and
 * compare it to what was asked for.
 *
 *   - If they match and this was a GET request, return the value.
 *
 *   - If the requested OID was lower and this is a GETNEXT request,
 *     return the value.
 *
 *   - Otherwise return nothing.
 */
int
sn_scalar_get(const sn_scalar *scalar,
	      const oid *base_oid, size_t base_oid_len,
	      const oid *req_oid, size_t req_oid_len, tbool exact,
	      oid *ret_oid, size_t *ret_oid_len,
	      void *ret_result, size_t result_buf_size, size_t *ret_result_len)
{
    int err = 0;
    int diff = 0;

    *ret_result_len = -1;

    memcpy(ret_oid, base_oid, base_oid_len * sizeof(oid));
    *ret_oid_len = base_oid_len;
    ret_oid[(*ret_oid_len)++] = 0;

    diff = snmp_oid_compare(req_oid, req_oid_len, ret_oid, *ret_oid_len);
    if ((exact && diff != 0) ||
	(!exact && diff >= 0)) {
	goto bail;
    }

    err = sn_get_snmp_value_by_name
	(scalar->ss_mgmt_node_name, scalar->ss_mgmt_db_name,
     scalar->ss_mgmt_node_type, ret_result, result_buf_size, 
     ret_result_len, NULL);
    bail_error(err);

 bail:
    return(err);
}
