/*
 *
 * URL:       $URL$
 * Revision:  $Revision: #1 $
 * Date:      $Date: 2017/11/02 $
 * Author:    $Author: build $
 *
 * (C) Copyright 2002-2012 Riverbed Technology, Inc.  
 * All rights reserved.
 *
 */

#ifndef __SN_MAIN_H_
#define __SN_MAIN_H_

static const char *rcsid_h__SN_MAIN_H_ __attribute__((unused)) =
    "$Id: //depot/prod/cag/R4.4.1x/net-snmp/net-snmp-5.7.1/include/net-snmp/agent/sn_main.h#1 $";

#ifdef __cplusplus
extern "C" {
#endif
#if 0 /* for emacs */
}
#endif

#include "common.h"
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/* ------------------------------------------------------------------------- */
/* main() is in snmpd.c and is part of NET-SNMP.  The Tall Maple SNMP
 * infrastructure. is one plug-in to NET-SNMP.  This file shows the
 * external interface that the Tall Maple SNMP infrastructure exposes
 * to NET-SNMP.
 */


/* ------------------------------------------------------------------------- */
/** The Tall Maple SNMP infrastructure's initialization function.
 * Make a connection to mgmtd and register our variables with NET-SNMP.
 *
 * NOTE: this (and all other SNMP MIB modules) is initialized before
 * the snmpd.conf config file is loaded.  One outcome of this is that
 * traps cannot be sent from our init function(s), as the trap
 * receivers are not yet set up.
 */
void sn_main_init(void);


/* ------------------------------------------------------------------------- */
/** Deinitialize the Tall Maple SNMP infrastructure.
 */
void sn_main_deinit(void);


/* ------------------------------------------------------------------------- */
/** The Tall Maple SNMP infrastructure's GET handlers for scalar and
 * columnar variables.  This is called when a GET or GETNEXT request
 * comes in and NET-SNMP determines that the answer or part of the 
 * answer should be one of the variables we have registered.
 * Note: NET-SNMP calls this function type FindVarMethod.
 */
u_char *
sn_get_handler_scalar(struct variable * vp,
		      oid * name,
		      size_t * length,
		      int exact,
		      size_t * var_len,
		      WriteMethod ** write_method);

u_char *
sn_get_handler_columnar(struct variable * vp,
			oid * name,
			size_t * length,
			int exact,
			size_t * var_len,
			WriteMethod ** write_method);

/*
 * Indicates whether or not snmpd is busy processing another request.
 * sn_awaiting_mgmt_reply cannot be used because right after a reply
 * is received it is set to false, where it could be picked up by
 * another event received at the same time as the reply.
 */
extern tbool sn_busy;

#ifdef __cplusplus
}
#endif

#endif /* _SN_MAIN_H_ */
