/*
 *
 * URL:       $URL$
 * Revision:  $Revision: #1 $
 * Date:      $Date: 2017/11/02 $
 * Author:    $Author: build $
 *
 * (C) Copyright 2002-2012 Riverbed Technology, Inc.  
 * All rights reserved.
 *
 */

#ifndef __SN_MGMT_H_
#define __SN_MGMT_H_

static const char *rcsid_h__SN_EVENT_H_ __attribute__((unused)) =
    "$Id: //depot/prod/cag/R4.4.1x/net-snmp/net-snmp-5.7.1/include/net-snmp/agent/sn_mgmt.h#1 $";

#ifdef __cplusplus
extern "C" {
#endif
#if 0 /* for emacs */
}
#endif

#include "bnode.h"
#include "bnode_proto.h"

/* ------------------------------------------------------------------------- */
/** Establish a connection with mgmtd and prepare to send requests and
 * receive replies.
 */
int sn_mgmt_init(void);


/* ------------------------------------------------------------------------- */
/** Close our connection with mgmtd.
 */
int sn_mgmt_shutdown(void);


/* ------------------------------------------------------------------------- */
/** Send a message to the management daemon, and return the response.
 * The response structure is the caller's responsibility to free.
 */
int sn_mgmt_send_msg(bn_request *req, bn_response **ret_resp);


/* ------------------------------------------------------------------------- */
/* Number of seconds before we'll give up on receiving a reply to a
 * request sent to the management daemon.
 */
static const lt_dur_sec sn_mgmt_timeout_sec = 30;


/* ------------------------------------------------------------------------- */
/* Handle queued-up events that occurred while we were in the middle
 * of doing something else.
 */
int sn_mgmt_handle_queued(void);


#ifdef __cplusplus
}
#endif

#endif /* __SN_MGMT_H_ */
