/*
 *
 * URL:       $URL$
 * Revision:  $Revision: #1 $
 * Date:      $Date: 2017/11/02 $
 * Author:    $Author: build $
 *
 * (C) Copyright 2002-2012 Riverbed Technology, Inc.
 * All rights reserved.
 *
 */

#ifndef __SN_NOTIFS_H_
#define __SN_NOTIFS_H_

static const char *rcsid_h__SN_NOTIFS_H_ __attribute__((unused)) =
    "$Id: //depot/prod/cag/R4.4.1x/net-snmp/net-snmp-5.7.1/include/net-snmp/agent/sn_notifs.h#1 $";

#ifdef __cplusplus
extern "C" {
#endif
#if 0 /* for emacs */
}
#endif

#include "bnode_proto.h"


/* ------------------------------------------------------------------------- */
/** Handle an event request.  Extract the event name and bindings from
 * the event and call sn_notif_handle_event().
 */
int sn_notif_handle_event_request(const bn_request *event_request);


/* ------------------------------------------------------------------------- */
/** Handle an event.  Look up the event name in the notification tables of
 * all of our MIBs, and send out any notifications it triggers.
 *
 * \param event_name The name of the event that has occurred.
 *
 * \param bindings The bindings that accompanied the event.
 */
int sn_notif_handle_event(const char *event_name, bn_binding_array *bindings);


#ifdef __cplusplus
}
#endif

#endif /* __SN_NOTIFS_H_ */
