/*
 *
 * URL:       $URL$
 * Revision:  $Revision: #1 $
 * Date:      $Date: 2017/11/02 $
 * Author:    $Author: build $
 *
 * (C) Copyright 2002-2012 Riverbed Technology, Inc.
 * All rights reserved.
 *
 */

#ifndef __SN_REGISTRATION_H_
#define __SN_REGISTRATION_H_

static const char *rcsid_h__SN_REGISTRATION_H_ __attribute__((unused)) =
    "$Id: //depot/prod/cag/R4.4.1x/net-snmp/net-snmp-5.7.1/include/net-snmp/agent/sn_registration.h#1 $";

#include "bnode.h"
#include "hash_table.h"
#include "sn_mod_reg.h"

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

#ifdef __cplusplus
extern "C" {
#endif
#if 0 /* for emacs */
}
#endif

/* ************************************************************************* */
/* ** Infrastructure interface to SNMP module registration                ** */
/* ************************************************************************* */

extern array *sn_reg_mibs;

/* ------------------------------------------------------------------------- */
struct sn_mib {
    const char *  sm_name;           /* Name of MIB                          */
    oid *         sm_base_oid;       /* Absolute base OID of MIB             */
    uint8         sm_base_oid_len;   /* Length of base OID                   */
    array *       sm_scalars;        /* Entries of type (sn_scalar *)        */
    array *       sm_tables;         /* Entries of type (sn_table *)         */
    ht_table *    sm_notifs;         /* Keys are (const char *) event names  */
                                     /* Values are (sn_notif *)              */
};


/* ------------------------------------------------------------------------- */
/** Initialize SNMP infrastructure registration.  Should be called by
 * the infrastructure before any modules try to initialize.
 */
int sn_reg_init(void);


/* ------------------------------------------------------------------------- */
/** To be called by the infrastructure after all modules have
 * registered their variables.  Converts the registrations into a form
 * palatable to NET-SNMP, and calls the NET-SNMP registration
 * function.
 */
int sn_reg_init_netsnmp(void);


#ifdef __cplusplus
}
#endif

#endif /* __SN_REGISTRATION_H_ */
